#!/usr/bin/env python3
"""
Spam Histogram 1
by Javantea
Dec 19, 2015

Answers the question "Is there more spam in the winter or is it just me?"

The data can be parsed poorly by gnuplot:
set timefmt "%Y-%m-%d %H:%i:%s"
set xdata time
set style data line
plot 'spam_histogram1a.dat' using 1:2

"""
import sys
import os
import datetime
import collections

spam_dir = '/home/jvoss/Mail/.inbox.directory/spam1/'
if len(sys.argv) > 1:
	spam_dir = sys.argv[1]
#end if

files = []
a = os.walk(spam_dir)
for b in a:
	files.append(b)
#next b

len(files[3][0])
#43
len(files[3][1])
#0
len(files[3][2])
#32400
messages = files[3][2]
c = [(msg.split('.')[0], msg) for msg in messages]
c.sort()
print(c[0])
#c[0][0]
#'1179470861'
int(c[0][0])
#1179470861
datetime.datetime.fromtimestamp(int(c[0][0]))
#datetime.datetime(2007, 5, 17, 23, 47, 41)
datetime.datetime.fromtimestamp(int(c[-1][0]))
#datetime.datetime(2015, 12, 18, 16, 58, 12)
histogram = collections.defaultdict(int)
for msgtime, msg in c:
    msgdate = datetime.datetime.fromtimestamp(int(msgtime))
    histogram[msgdate.strftime('%Y-%m-%d')] += 1

v = list(histogram.items())
v.sort()
v[:20]
#[('2015-04-08', 18), ('2008-08-10', 16), ('2009-02-09', 9), ('2010-08-30', 1), ('2010-08-31', 1), ('2008-08-17', 17), ('2008-10-05', 9), ('2009-10-05', 1), ('2009-10-06', 1), ('2015-08-08', 58), ('2015-08-09', 24), ('2015-08-06', 69), ('2015-08-07', 114), ('2015-08-04', 94), ('2015-08-05', 71), ('2015-08-02', 64), ('2015-08-03', 118), ('2015-08-01', 79), ('2015-09-12', 17), ('2014-07-04', 13)]
open('spam_histogram1_{0}.dat'.format(spam_dir.replace(os.environ['HOME'], '').strip(os.sep).replace(os.sep, '_')), 'w').write('\n'.join(['%s %i'% x for x in v]))

